<?php
error_reporting(E_ALL & ~E_NOTICE);
define('ok', true);
header('Access-Control-Allow-Origin', '*');
header("Content-Type: text/html;charset=utf-8");
date_default_timezone_set('PRC');

class SetUserInfo
{
    private $pdo;

    public function __construct($pdo)
    {
        $this->pdo = $pdo;
    }

    public function setInfo($openid, $token, $headimgurl, $nickname, $at, $rt)
    {
        $result = array(
            'state' => 0,
            'msg' => 'get error'
        );
        $nickname = $this->filterEmoji($nickname);
        //
        $st = $this->pdo->prepareSql("select * from user_info where openid =?");
        $st->bindParam(1, $openid);
        $st->execute();
        $data2 = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        $time = date('Y-m-d H:i:s') . "";

        if (empty ($data2)) { //新建用户
            if (!empty ($at) && !empty ($rt)) {
                $userId = $this->getUserId($at, $rt);
            }
            $result = $this->initData($openid, $token, $headimgurl, $nickname, $userId);
        } else { //返回用户当前数据情况
            if (empty ($data2["userId"])) {
                if (!empty ($at) && !empty ($rt)) {
                    $userId = $this->getUserId($at, $rt);
                    //更新一次
                    $updateArr = array(
                        'userId' => $userId,
                    );
                    $where = "`openid`='" . $openid . "'";
                    $this->pdo->update("user_info", $updateArr, $where);
                    // $data2["userId"] = $userId;
                }
            }
            $result['state'] = 1;
            $result['data'] = $data2;
            $result['getDate'] = $time;
            $result['msg'] = 'get data success';
        }
        return $result;
    }

    //去除微信特殊字符
    public function filterEmoji($str)
    {
        $str = preg_replace_callback(
            '/./u',
            function (array $match) {
                return strlen($match[0]) >= 4 ? '' : $match[0];
            },
            $str
        );
        return $str;
    }

    public function getUserId($at, $rt)
    {
        $path = "http://p-passport-service.zpidc.com/passport-service/userService/getUserTokenByAt?at=" . $at;
        $res = json_decode($this->curlGet($path));
        if ($res->code == 200) {
            if (!empty ($res->data)) {
                return $res->data->userId;
            } else {
                $this->logInfo("at:" . $at . ":rt:" . $rt . json_encode($res));
                return 0;
            }
        } else {
            $this->logInfo("at:" . $at . ":rt:" . $rt . json_encode($res));
            return 0;
        }
    }

    public function logInfo($logs)
    {
        //做一下日志输入
        $file = './log/userid.log';
        $f = file_put_contents($file, $logs, FILE_APPEND);
    }

    public function initData($openid, $token, $headimgurl, $nickname, $userId)
    {
        $result = array(
            'state' => 0,
            'msg' => 'get error'
        );
        $time = date('Y-m-d H:i:s') . "";
        $userId = empty ($userId) ? "" : $userId;
        $insertArr = array(
            'unionid' => '',
            'openid' => $openid,
            'token' => $token,
            'avatarUrl' => $headimgurl,
            'nickName' => $nickname,
            'userId' => $userId,
            'registerDate' => $time
        );
        //没有数据，插入
        $flag = $this->pdo->insert("user_info", $insertArr);
        if (!empty ($flag)) {
            $insertArr["userId"] = "";
            $result['state'] = 1;
            $result['getDate'] = $time;
            $result['msg'] = 'insert success';
            $result['data'] = $insertArr;
        }
        return $result;
    }

    public function curlGet($url)
    {
        $curl = curl_init(); // 启动一个CURL会话
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, true);  // 从证书中检查SSL加密算法是否存在
        $tmpInfo = curl_exec($curl);     //返回api的json对象
        //关闭URL请求
        curl_close($curl);
        return $tmpInfo;    //返回json对象
    }

    public function curlPost($url, $data)
    {
        $curl = curl_init(); // 启动一个CURL会话
        curl_setopt($curl, CURLOPT_URL, $url); // 要访问的地址
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0); // 对认证证书来源的检查
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 1); // 从证书中检查SSL加密算法是否存在
        curl_setopt($curl, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']); // 模拟用户使用的浏览器
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1); // 使用自动跳转
        curl_setopt($curl, CURLOPT_AUTOREFERER, 1); // 自动设置Referer
        curl_setopt($curl, CURLOPT_POST, 1); // 发送一个常规的Post请求
        curl_setopt($curl, CURLOPT_POSTFIELDS, $data); // Post提交的数据包
        curl_setopt($curl, CURLOPT_TIMEOUT, 30); // 设置超时限制防止死循环
        curl_setopt($curl, CURLOPT_HEADER, 0); // 显示返回的Header区域内容
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); // 获取的信息以文件流的形式返回
        $tmpInfo = curl_exec($curl); // 执行操作
        if (curl_errno($curl)) {
            echo 'Errno' . curl_error($curl); //捕抓异常
        }
        curl_close($curl); // 关闭CURL会话
        return $tmpInfo; // 返回数据
    }
}
require_once './cfgSQL.php';
require_once './MyPDO.php';
//参数
$openid = isset ($_REQUEST["openid"]) ? $_REQUEST["openid"] : "";
$token = isset ($_REQUEST["token"]) ? $_REQUEST["token"] : "";
$at = isset ($_REQUEST["at"]) ? $_REQUEST["at"] : "";
$rt = isset ($_REQUEST["rt"]) ? $_REQUEST["rt"] : "";
$headimgurl = urldecode(isset ($_REQUEST["headimgurl"]) ? $_REQUEST["headimgurl"] : "");
$nickname = urldecode(isset ($_REQUEST["nickname"]) ? $_REQUEST["nickname"] : "");
if (empty ($openid)) {
    exit ('{"code": -1,"msg": "参数不能为空"}');
}
//
$pdo = DAOPDO::getInstance(DB_HOST, DB_USER, DB_PASS, DB_NAME, 'utf8');
$userInfo = new SetUserInfo($pdo);
$signPackage = $userInfo->setInfo($openid, $token, $headimgurl, $nickname, $at, $rt);
$result = json_encode($signPackage);
echo $result;
