<?php
error_reporting(E_ALL & ~E_NOTICE);
define('ok', true);
header('Access-Control-Allow-Origin', '*');
header("Content-Type: text/html;charset=utf-8");
date_default_timezone_set('PRC');

class SetUserInfo
{
    private $pdo;

    public function __construct($pdo)
    {
        $this->pdo = $pdo;
    }

    public function setInfo($code)
    {
        $result = array(
            'state' => 0,
            'msg' => 'get error'
        );
        //通过code拿去openid
        $appid = APPID;
        $appSecret = APPSECRET;
        $url = "https://api.weixin.qq.com/sns/jscode2session?appid=$appid&secret=$appSecret&js_code=$code&grant_type=authorization_code";
        $authData = file_get_contents($url);
        $authData = (array)json_decode($authData);
        $openid = $authData["openid"];
        $unionid = isset($authData["unionid"]) ? $authData["unionid"] : "";
        if (empty($openid)) {
            return $result;
        }
        //先去查询是否已注册了
        $info = $this->getUserInfo($openid);
        if (empty($info)) {
            $token = md5($openid . 'duefox');
            $time = date('Y-m-d H:i:s') . "";
            $info = $this->updateInitData($openid, $unionid, $token);
        }
        if (!empty($info)) {
            $result["state"] = 1;
            $result["data"] = $info;
            $result["msg"] = 'get data succ';
        }
        $result["getTime"] = $time;
        return $result;
    }

    public function getUserInfo($openid)
    {
        $st = $this->pdo->prepareSql("select id,unionid,openid,token,avatarUrl,qrcodeUrl,commentCnt,nickName,score,name,phone,userId from user_info where openid =?");
        $st->bindParam(1, $openid);
        $st->execute();
        $data = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        return $data;
    }

    public function updateInitData($openid, $unionid, $token)
    {
        // 是否有数据了，有则修改，无则插入
        $st = $this->pdo->prepareSql("select * from user_info where openid =?");
        $st->bindParam(1, $openid);
        $st->execute();
        $usrData = $st->fetchAll(PDO::FETCH_ASSOC)[0];
        $time = date('Y-m-d H:i:s') . "";
        $insertArr = array(
            'openid' => $openid,
            'unionid' => $unionid,
            'token' => $token
        );
        if (empty($usrData)) {
            $insertArr["registerDate"] = $time;
            //没有数据，插入
            $this->pdo->insert("user_info", $insertArr);
        } else { //更新数据
            $where = "`openid`='" . $openid . "'";
            $this->pdo->update("user_info", $insertArr, $where);
        }
        return $insertArr;
    }
}
require_once './cfgSQL.php';
require_once './MyPDO.php';
//参数
$code = isset($_REQUEST["code"]) ? $_REQUEST["code"] : "";

if (empty($code)) {
    exit('{"code": -1,"msg": "参数不能为空"}');
}
//
$pdo = DAOPDO::getInstance(DB_HOST, DB_USER, DB_PASS, DB_NAME, 'utf8');
$userInfo = new SetUserInfo($pdo);
$signPackage = $userInfo->setInfo($code);
$result = json_encode($signPackage);
echo $result;
