var MakePhoto = MakePhoto || {};
MakePhoto = (function () {
    var newCtx = null;
    var newCanvas = null;
    //
    MakePhoto.setSize = function (ww, hh, color) {
        newCanvas = document.createElement('canvas');
        newCtx = newCanvas.getContext("2d");
        newCtx.textAlign = 'left';
        newCanvas.width = ww;
        newCanvas.height = hh;
        newCtx.fillStyle = color;
        newCtx.fillRect(0, 0, ww, hh);
    };
    //
    MakePhoto.addImg = function (list, cbk) {
        var len = list.length;

        function drawing(n) {
            if (n < len) {
                var img = new Image();
                img.src = list[n]['src'];
                // img.setAttribute('crossorigin', 'anonymous'); // 注意设置图片跨域应该在图片加载之前
                img.crossOrigin = '*'; //可选值：anonymous，*
                //fit:fitWD fitHG cover showAll
                //{src: './images.png', x: 590, y: 380, w: 421, h: 414}
                img.onload = function () {
                    if (img.complete) {
                        //console.log(list[n]);
                        var x = list[n]['x'];
                        var y = list[n]['y'];
                        //
                        if (!list[n]['w']) {
                            //默认居中
                            x = list[n]['x'] - img.width * 0.5;
                            y = list[n]['y'] - img.height * 0.5;
                            var fit = list[n]['fit'];
                            var align = list[n]['align'];
                            var scale = newCanvas.width / newCanvas.height;
                            var imgScale = img.width / img.height;
                            if (fit == "showAll") {
                                if (imgScale > scale) {
                                    fitWD(img, list[n]);
                                } else {
                                    fitHG(img, list[n]);
                                }
                            } else if (fit == "cover") {
                                if (imgScale < scale) {
                                    fitWD(img, list[n]);
                                } else {
                                    fitHG(img, list[n]);
                                }
                            } else if (fit == "fitWD") {
                                fitWD(img, list[n]);
                            } else if (fit == "fitHG") {
                                fitHG(img, list[n]);
                            } else { //居中适配
                                if (align == 'right') {
                                    x = list[n]['x'] - img.width;
                                } else if (align == 'left') {
                                    x = list[n]['x'];
                                } else if (align == 'center') {
                                    x = list[n]['x'] - img.width * 0.5;
                                    y = list[n]['y'] - img.height * 0.5;
                                } else {
                                    x = list[n]['x'];
                                    y = list[n]['y'];
                                }
                                newCtx.drawImage(img, x, y);
                            }
                        } else {
                            newCtx.drawImage(img, x, y, list[n]['w'], list[n]['h']);
                        }
                        drawing(n + 1); //递归
                    }
                }
                img.onerror = function () {
                    drawing(n + 1); //递归
                    if (cbk) {
                        cbk(-1);
                    }
                }
            } else {
                if (cbk) {
                    cbk();
                }
            }
        }

        drawing(0);

        //
        function fitWD(img, listItem) {
            var w = newCanvas.width;
            var scale = w / img.width;
            var h = Math.floor(img.height * scale);
            var x = listItem['x'] - w * 0.5;
            var y = listItem['y'] - h * 0.5;
            newCtx.drawImage(img, x, y, w, h);
        }

        function fitHG(img, listItem) {
            var h = newCanvas.height;
            var scale = h / img.height;
            var w = Math.floor(img.width * scale);
            var x = listItem['x'] - w * 0.5;
            var y = listItem['y'] - h * 0.5;
            newCtx.drawImage(img, x, y, w, h);
        }
    };
    /**
     * 
     * @param {*} text 文本字符
     * @param {*} x x坐标
     * @param {*} y y坐标
     * @param {*} color 颜色值，推荐rga(0,0,0)模式
     * @param {*} fontSize 字体大小
     * @param {*} fontName 字体名称
     * @param {*} textAlign 对齐方式
     * @param {*} lineWidth 列间距
     * @param {*} lineHeight 行间距
     * @param {*} bold 是否加粗
     */
    MakePhoto.addFont = function (text, x, y, color, fontSize, fontName, textAlign, bold, rotation, lineWidth, lineHeight) {
        //font = 'normal bold 36px Arial,sans-serif'
        if (!fontName) {
            fontName = 'Arial,sans-serif';
        } else {
            fontName = fontName + ',sans-serif';
        }
        if (!textAlign) {
            textAlign = 'center';
        }
        if (fontSize) {
            newCtx.font = fontSize + "px " + fontName;
        } else {
            newCtx.font = "38px " + fontName;
        }
        if (!lineHeight) {
            lineHeight = fontSize * 2; //行间距
        }
        if (!lineWidth) {
            lineWidth = fontSize * 2; //列间距
        }
        if (bold && bold != undefined) {
            newCtx.font = "normal bold " + newCtx.font;
        }
        newCtx.fillStyle = color;
        newCtx.textAlign = textAlign; //添加的一行代码
        var rowCount = 0;
        //newCtx.fillText(text, x, y);
        for (var i = 1; getTrueLength(text) > 0; i++) {
            var tl = cutString(text, lineWidth);
            var trueText = text.substr(0, tl);
            text = text.substr(tl); //
            var lastText = text;
            //判断最后一个字符为标点符号则不换行
            if (isChineseMarks(lastText)) {
                trueText += lastText;
                text = "";
            }
            if (rotation) { //旋转画布
                var newCtx2 = newCanvas.getContext("2d");
                newCtx2.translate(newCanvas.width * 0.5, 0);
                newCtx2.rotate(rotation);
                //绘制文本
                newCtx2.fillText(trueText, x, y + (i - 1) * lineHeight);
                //绘制后恢复旋转角度，否则会乱
                newCtx2.translate(-newCanvas.width, 0);
                newCtx2.rotate(-rotation);
            } else {
                //绘制文本
                newCtx.fillText(trueText, x, y + (i - 1) * lineHeight);
            }
            rowCount++;
        }
        //判断最后一个字符是否中文标点符号
        function isChineseMarks(text) {
            if (text.length > 1) return false;
            //匹配这些中文标点符号 。 ？ ！ ， 、 ； ： “ ” ‘ ' （ ） 《 》 〈 〉 【 】 『 』 「 」 ﹃ ﹄ 〔 〕 … — ～ ﹏ ￥
            var reg = /[\u3002|\uff1f|\uff01|\uff0c|\u3001|\uff1b|\uff1a|\u201c|\u201d|\u2018|\u2019|\uff08|\uff09|\u300a|\u300b|\u3008|\u3009|\u3010|\u3011|\u300e|\u300f|\u300c|\u300d|\ufe43|\ufe44|\u3014|\u3015|\u2026|\u2014|\uff5e|\ufe4f|\uffe5]/;
            if (reg.test(text)) {
                return true;
            } else {
                return false;
            }
        }
        //
        function getTrueLength(str) { //获取字符串的真实长度（字节长度）
            var len = str.length,
                truelen = 0;
            for (var x = 0; x < len; x++) {
                if (str.charCodeAt(x) > 128) {
                    truelen += 2;
                } else {
                    truelen += 1;
                }
            }
            return truelen;
        }

        function cutString(str, leng) { //按字节长度截取字符串，返回substr截取位置
            var len = str.length,
                tlen = len,
                nlen = 0;
            for (var x = 0; x < len; x++) {
                if (str.charCodeAt(x) > 128) {
                    if (nlen + 2 < leng) {
                        nlen += 2;
                    } else {
                        tlen = x;
                        break;
                    }
                } else {
                    if (nlen + 1 < leng) {
                        nlen += 1;
                    } else {
                        tlen = x;
                        break;
                    }
                }
            }
            return tlen;
        }
        //返回行数
        return rowCount;
    };

    MakePhoto.clear = function () {
        newCtx.clearRect(0, 0, newCanvas.width, newCanvas.height);
    };

    MakePhoto.build = function (type) {
        console.log('build picture');
        if (!type) {
            type = "image/png"; //"image/jpeg";
        }
        return newCanvas.toDataURL(type);
    };

    MakePhoto.blur = function (blurValue) {
        if (typeof StackBlur != 'undefined') {
            StackBlur.canvasRGB(
                newCanvas, 0, 0, newCanvas.width, newCanvas.height, blurValue
            );
        }
    };

    return {
        addImg: MakePhoto.addImg,
        setSize: MakePhoto.setSize,
        addFont: MakePhoto.addFont,
        clear: MakePhoto.clear,
        build: MakePhoto.build,
        blur: MakePhoto.blur,
    }
})();

CanvasRenderingContext2D.prototype.letterSpacingText = function (text, x, y, letterSpacing) {
    var context = this;
    var canvas = context.canvas;

    if (!letterSpacing && canvas) {
        letterSpacing = parseFloat(window.getComputedStyle(canvas).letterSpacing);
    }
    if (!letterSpacing) {
        return this.fillText(text, x, y);
    }

    var arrText = text.split('');
    var align = context.textAlign || 'left';
    // 这里仅考虑水平排列
    var originWidth = context.measureText(text).width;
    // 应用letterSpacing占据宽度
    var actualWidth = originWidth + letterSpacing * (arrText.length - 1);
    // 根据水平对齐方式确定第一个字符的坐标
    if (align == 'center') {
        x = x - actualWidth / 2;
    } else if (align == 'right') {
        x = x - actualWidth;
    }
    // 临时修改为文本左对齐
    context.textAlign = 'left';
    // 开始逐字绘制
    arrText.forEach(function (letter) {
        var letterWidth = context.measureText(letter).width;
        context.fillText(letter, x, y);
        // 确定下一个字符的横坐标
        x = x + letterWidth + letterSpacing;
    });
    // 对齐方式还原
    context.textAlign = align;
};