/**
 * Created by zhonghua.xie on 2023/1/9.
 */
var MainLayer = cc.LayerColor.extend({
    _crtLayer: null,
    arrow: null,
    logo: null,
    menuItems: [],

    ctor: function () {
        this._super(cc.color(177, 235, 254, 255));
        GC._layerArr = [];
        GC.btnMusic = null;
        GC._clsArr = [
            PageHome, PageQuest, PageResult, PageTag, PageInvite
        ];
        /** @expose */
        mainGame = this;
        GC.menuItems = [];
        GC.menu = new cc.Menu();
        GC.menu.x = 0;
        GC.menu.y = 0;
        this.setData();
        return true;
    },

    setData: function () {
        this.initLogo();
        this.initArrow();
        this.initQuickMenu();
        //
        GC.isMusic = true;
        if (DTools.ua.weixin) {
            DTools.bgmAudio.play();
        } else {
            DTools.bgmAudio.pause();
            this.onTouchMusic();
            $('.btnCloseMusic').addClass('musicPause');
        }
        //
        this.initUI();
        this.addTouch();
        //
        GC.isMusic = true;
    },

    initUI: function () {
        //缓存序列帧动画
        this.initFrameAnimate("dot_000", 3, 3);
        // this.initFrameAnimate2("res/bg/bg_000", 'png?v=' + _v, cc.rect(0, 0, 750, 1514), "bg_000", 60, 24);
        //把图加入到缓存
        var frame = new cc.SpriteFrame(res.btnBonus2_png, cc.rect(0, 0, 321, 156));
        cc.spriteFrameCache.addSpriteFrame(frame, res.btnBonus2_png);
        for (var i = 0; i < 4; i++) {
            //var frame = new cc.SpriteFrame(res["scene_" + i + "_png"], cc.rect(0, 0, 660, 688));
            //cc.spriteFrameCache.addSpriteFrame(frame, res["scene_" + i + "_png"]);
        }
        this.initOrgAction();
        //
        GC.isOver = false;
        GC.pageId = 0;
        cc.log("isFromShare:", GC.isFromShare, "score:", GC.score);
        console.log("GC.oid:", GC.oid, "GC.at:", GC.at, "GC.rt:", GC.rt);
        //入口判定逻辑
        if (GC.isFromShare) { //来自分享，则直接去打标页
            GC.pageId = 4;
        } else {
            if (GC.score && GC.score > 0) { //已测试过的用户
                //分俩种情况：1：没评论去结果页，2：有评论去查看标签页
                if (GC.infoData["commentCnt"]) {
                    GC.pageId = 3;
                } else {
                    GC.pageId = 2;
                }
                this.nopasspott();
            } else { //未测试过的新手
                GC.pageId = GC.cbk || 0;
            }
        }
        // GC.pageId = 1;
        mainGame.changePage(0);
    },

    //cbk的值是回跳页面参数值
    nopasspott: function (cbk = 0) {
        if (DTools.util.isLocalNet()) {
            return;
        }
        if (GC.at != "") return;
        //这里还要处理特殊情况，有的人清空了at要跳转回智联
        if (GC.at == "") {
            var path = "https://passport.zhaopin.com/additional/m";
            path += "?appID=" + GC.appid + "&refer=5003380&redirectURL=" + encodeURIComponent(GC.host + "?cbk=" + cbk);
            cc.log(path);
            window.location.replace(path);
        }
    },

    changePage: function (dir, cutObj) {
        canChangePage = false;
        if (cutObj) {
            var cutScreen = cutObj["cutScreen"];
            var inTime = cutObj["inTime"];
            var outTime = cutObj["outTime"];
            this.addChild(cutScreen, 9999, 9999);
            cutScreen.runAction(cutScreen.actAnimate);
            //出场时间点
            this.scheduleOnce(function () {
                this.noCutChangePage(dir);
            }.bind(this), inTime);
            //结束时间点
            this.scheduleOnce(function () {
                cutScreen.removeFromParent(true);
                cutScreen = null;
            }.bind(this), outTime);
        } else {
            this.noCutChangePage(dir);
        }
    },
    //无过场动画
    noCutChangePage(dir) {
        if (this._crtLayer) {
            this.reorderChild(this._crtLayer, 8, 8);
            this._crtLayer.delMenuItems();
            this._crtLayer.disappear(dir);
        }
        cc.log("GC.pageId:", GC.pageId);
        //
        if (this._crtLayer) {
            this._crtLayer.removeFromParent(true);
            this._crtLayer = null;
        }
        var _layer = new GC._clsArr[GC.pageId];
        this._crtLayer = _layer;
        this.addChild(_layer, 9, 9);
        GC._layerArr[GC.pageId] = this._crtLayer;
        this._crtLayer.appear(dir);
    },

    changeGetBonusPic: function () {
        if (this._crtLayer) {
            this._crtLayer.changeGetBonusPic();
        }
    },

    showIptTips: function (flag) {
        if (this._crtLayer) {
            this._crtLayer.showIptTips(flag);
        }
    },

    initLogo() {
        var logo = new cc.Sprite(res.logo_png);
        logo.anchorX = 0;
        logo.x = 0;
        logo.y = GC.h_2 + 550 + GC.biggerOffsetY;
        this.addChild(logo, 998, 998);
        this.logo = logo;
    },

    showLogo: function (isShow, point = null) {
        this.logo.visible = isShow;
        if (point) {
            this.logo.setPosition(point);
        }
    },

    initArrow: function () {
        var dirTips = new cc.Sprite(res.dir_png);
        dirTips.x = GC.w_2;
        dirTips.xx = dirTips.x;
        dirTips.y = GC.h_2 - 600 - GC.biggerOffsetY;
        dirTips.yy = dirTips.y;
        dirTips.opacity = 0;
        dirTips.visible = false;
        this.addChild(dirTips, 115, 115);
        this.arrow = dirTips;
        this.scheduleOnce(function () {
            dirTips.runAction(cc.sequence(
                cc.spawn(
                    cc.fadeOut(0.8),
                    cc.moveBy(0.8, cc.p(0, 30)).easing(cc.easeSineOut())
                ),
                cc.delayTime(0.3),
                cc.callFunc(function () {
                    dirTips.opacity = 255;
                    dirTips.y = dirTips.yy;
                }.bind(this), this)
            ).repeatForever());
        }.bind(this), 1.0);
    },

    showArrow: function (flag) {
        this.arrow.visible = flag;
    },

    initQuickMenu: function () {
        var menuRes = [res.btnMusicOn_png];
        for (var i = 0, len = menuRes.length; i < len; i++) {
            var itemMenu = new cc.MenuItemImage(menuRes[i]);
            itemMenu.tid = i;
            itemMenu.anchorX = 1;
            if (i == 0) {
                GC.btnMusic = itemMenu;
                itemMenu.anchorY = 1;
                itemMenu.x = GC.w - 30;
                itemMenu.y = GC.h - 30;
            } else {
                itemMenu.x = GC.w - 30;
                itemMenu.y = GC.btnMusic.y - 70;
            }
            itemMenu.setCallback(this.onTouchStart.bind(this), this);
            this.menuItems[i] = itemMenu;
        }
        //
        var _menu = new cc.Menu();
        _menu.initWithArray(this.menuItems);
        _menu.x = 0;
        _menu.y = 0;
        this.addChild(_menu, 199, 199);
    },

    onTouchStart: function (sender) {
        if (GC.isPop) return;
        if (!sender || sender.tid == 0) {
            this.onTouchMusic(sender);
        } else {
            DTools.soundAudio.play("touchAudio");
            if (sender.tid == 1) { //规则
                if (GC.popupRuler) {
                    GC.popupRuler.removeAllChildren();
                    GC.popupRuler.removeFromParent(true);
                    GC.popupRuler = null;
                }
                GC.popupRuler = new PopupRuler(res.popupRuler_png, function (arg) {});
                mainGame.addChild(GC.popupRuler, 999, 999);
            }
        }
    },

    onTouchMusic: function (sender) {
        GC.isMusic = !GC.isMusic;
        var sender = sender || GC.btnMusic;
        if (GC.isMusic) {
            DTools.bgmAudio.play();
            //sender.runAction(sender.action.clone());
            sender.setNormalSpriteFrame(res.btnMusicOn_png);
            if ($('.btnCloseMusic').hasClass("musicPause")) {
                $('.btnCloseMusic').removeClass('musicPause');
            }
        } else {
            DTools.bgmAudio.pause();
            //sender.stopAllActions();
            sender.setNormalSpriteFrame(res.btnMusicOff_png);
            if (!$('.btnCloseMusic').hasClass("musicPause")) {
                $('.btnCloseMusic').addClass('musicPause');
            }
        }
    },

    //显示快捷菜单，0-音乐开关，1-后退，2-规则
    showQuickIcon: function (quickIndexArr = []) {
        for (var i = 0, len = this.menuItems.length; i < len; i++) {
            var menuItem = this.menuItems[i];
            menuItem.visible = false;
        }
        for (var j = 0, len2 = quickIndexArr.length; j < len2; j++) {
            var index = quickIndexArr[j];
            this.menuItems[index].visible = true;
        }
    },

    setMusicPos: function (pos) {
        GC.btnMusic.x = pos.x;
        GC.btnMusic.y = pos.y;
    },

    initFrameAnimate: function (flag, cnt, fps) {
        if (!fps) {
            fps = cnt;
        }
        var animFrames = [],
            str = "",
            frame;
        for (var i = 0; i < cnt; i++) {
            str = flag + (i < 10 ? ("0" + i) : i) + ".png";
            frame = cc.spriteFrameCache.getSpriteFrame(str);
            animFrames.push(frame);
        }
        var animation = new cc.Animation(animFrames, 1 / fps);
        cc.animationCache.addAnimation(animation, flag);
        return new cc.Sprite("#" + flag + "00.png");
    },

    initFrameAnimate2: function (path, ext, rect, flag, cnt, fps) {
        if (fps == undefined || fps == null) {
            fps = 12;
        }
        var animFrames = [];

        for (var i = 0; i < cnt; i++) {
            var res = path + (i < 10 ? ("0" + i) : i) + "." + ext;
            var frame = cc.SpriteFrame.createWithTexture(res, rect);
            //添加到缓存
            var frame = new cc.SpriteFrame(res, rect);
            cc.spriteFrameCache.addSpriteFrame(frame, res);
            //
            animFrames.push(frame);
        }
        var animation = new cc.Animation(animFrames, 1 / fps);
        cc.animationCache.addAnimation(animation, flag);
        return new cc.Sprite(path + "00." + ext);
    },

    addTouch: function () {
        cc.log("addTouch");
        var self = this;
        self.listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowtouch: true,
            startPos: 0,
            _dt: new Date().getTime(),
            _touchMoved: false,
            _touchEnd: true,
            _touchPoint: null,
            _touchBeginPos: null,
            _longPressDelay: 0.6, //单位：秒

            onTouchBegan: function (touch, event) {
                if (GC.gameLock) return false;
                this.startPos = touch.getLocation();
                if (!GC.isPop) {
                    self._crtLayer.getTouchBegan(touch, event);
                }
                this._touchPoint = self.convertTouchToNodeSpace(touch);
                this._touchBeginPos = this._touchPoint;
                this._dt = new Date().getTime();
                this._touchEnd = false;
                self.scheduleOnce(function () { //倒计时到时候目标没移动也也抬手
                    if (!this._touchMoved && !this._touchEnd) {
                        cc.log("long press no move");
                        if (!GC.isPop) {
                            self._crtLayer.getLongPress(touch, event);
                        }
                    }
                }.bind(this), 0.6);
                return true;
            },

            onTouchMoved: function (touch, event) {
                //cc.log("onTouchMoved");
                this._touchMoved = true;
                if (!GC.isPop) {
                    self._crtLayer.getTouchMoved(touch, event);
                }
                //长按事件
                var dtGap = new Date().getTime() - this._dt;
                var point2 = self.convertTouchToNodeSpace(touch);
                var diffX = point2.x - this._touchBeginPos.x;
                var diffY = point2.y - this._touchBeginPos.y;
                if (Math.abs(diffX) < 3 && Math.abs(diffY) < 3 && dtGap > 600) { //长按
                    cc.log("longPress move lite");
                    if (!GC.isPop) {
                        self._crtLayer.getLongPress(touch, event);
                    }
                }
                return true;
            },

            onTouchEnded: function (touch, event) {
                //cc.log("onTouchEnded", GC.pageId);
                if (!GC.isPop) {
                    self._crtLayer.getTouchEnded(touch, event);
                }
                var newPoint = touch.getLocation();
                self.getOnTouch(0, newPoint);
                self.getSwipeTouch(newPoint.x - this.startPos.x, newPoint.y - this.startPos.y);
                this._touchMoved = false;
                this._touchEnd = true;
                return true;
            },
            onTouchCancelled: function (touch, event) {
                if (!GC.isPop) {
                    self._crtLayer.getTouchCancelled(touch, event);
                }
                event.stopPropagation();
                // event.preventDefault();
            }
        });
        cc.eventManager.addListener(self.listener, self);
    },

    getOnTouchMoved: function (touch, event) {
        //cc.log("main getOnTouchMoved");
        if (this._crtLayer) {
            this._crtLayer.getOnTouchMoved(touch, event);
        }
    },

    getOnTouch: function (arg, piont) {
        if (this._crtLayer) {
            this._crtLayer.touchSelf(arg, piont);
        }
    },

    getSwipeTouch: function (disX, disY) {
        if (!(GC.pageId == 1 || GC.pageId == 2 || GC.pageId == 3)) return;
        var xx = Math.abs(disX);
        var yy = Math.abs(disY);
        var dirX = disX > 0 ? 1 : -1;
        var dirY = disY > 0 ? 1 : -1;
        if (xx < 8) {
            dirX = 0;
        }
        if (yy < 8) {
            dirY = 0;
        }
        if (this._crtLayer) {
            this._crtLayer.swipeSelf(dirX, dirY);
        }
    },

    getFloatAction: function (item, flag = "y", dt = 0.5, distanece = 20, isRepeat = true) {
        var ix, iy, xx, yy;
        if (flag == "x") {
            ix = item.x;
            iy = item.y;
            xx = item.x + distanece;
            yy = item.y;
        } else {
            ix = item.x;
            iy = item.y;
            xx = item.x;
            yy = item.y + distanece;
        }
        var act = cc.sequence(
            cc.moveTo(dt, cc.p(ix, iy)).easing(cc.easeSineInOut()),
            cc.moveTo(dt, cc.p(xx, yy)).easing(cc.easeSineInOut())
        );
        if (isRepeat) {
            return act.repeatForever();
        } else {
            return act;
        }
    },

    initOrgAction: function () {
        GC.tipsAction = cc.sequence(
            cc.spawn(
                cc.scaleTo(0.3, 1.2).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 255)
            ),
            cc.spawn(
                cc.scaleTo(0.4, 1).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 220)
            )
        ).repeatForever();
        GC.tipsAction2 = cc.sequence(
            cc.spawn(
                cc.scaleTo(0.3, 1.1).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 255)
            ),
            cc.spawn(
                cc.scaleTo(0.4, 1).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 180)
            )
        ).repeatForever();
        GC.tipsAction3 = cc.sequence(
            cc.spawn(
                cc.scaleTo(0.3, 0.9).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 255)
            ),
            cc.spawn(
                cc.scaleTo(0.4, 1).easing(cc.easeSineOut()),
                cc.fadeTo(0.5, 240)
            )
        ).repeatForever();
        GC.shakeAction = cc.sequence(
            cc.scaleTo(0.3, 1.06).easing(cc.easeSineOut()),
            cc.delayTime(0.1),
            cc.scaleTo(0.3, 1).easing(cc.easeSineOut())
        );
        GC.flipAction = cc.sequence(
            cc.scaleTo(0.3, 1, 0).easing(cc.easeSineOut()),
            cc.delayTime(0.1),
            cc.scaleTo(0.3, 1).easing(cc.easeSineOut())
        );
        GC.rotateAction = cc.sequence(
            cc.rotateTo(2.5, 10),
            cc.rotateTo(2.5, -10),
        ).repeatForever();
        GC.blinkAction = cc.sequence(
            cc.fadeTo(0.5, 0),
            cc.delayTime(0.5),
            cc.fadeTo(0.5, 255)
        ).repeatForever();
    }
});

var PageLayer = cc.LayerColor.extend({
    _cbk: null,
    _showArrow: false,
    timeText: true,
    textItemArr: [],
    pageId: 0,

    ctor: function () {
        this._super(cc.color(177, 235, 254, 255));
        mainGame.showQuickIcon([]);
        mainGame.showLogo(false);
        this.delMenuItems();
        this.pageId = GC.pageId;
        return true;
    },

    appear: function (changeType, delay) {
        if (delay == undefined || delay == null) {
            delay = 0.7;
        }
        canChangePage = true;
        if (changeType == 1) { //from right to center
            this.x = 0;
            this.y = -GC.h;
        } else if (changeType == -1) { //from left to center
            this.x = 0;
            this.y = GC.h;
        }
        this.setVisible(true);
        var self = this;
        if (changeType == 0) {
            this.runAction(
                cc.sequence(
                    cc.delayTime(delay),
                    cc.callFunc(function () {
                        self.showItems();
                    }.bind(this), this)
                )
            );
        } else if (changeType == 1 || changeType == -1) {
            this.runAction(
                cc.sequence(
                    cc.moveTo(GC.easeDT, cc.p(0, 0)),
                    cc.delayTime(delay),
                    cc.callFunc(function () {
                        self.showItems();
                    }.bind(this), this)
                )
            );
        }
    },

    disappear: function (changeType) {
        var posY = 0;
        if (changeType == -1) { //from center to right
            posY = -GC.h;
        } else if (changeType == 1) { //from center to left
            posY = GC.h;
        }
        var self = this;
        if (changeType != 0) {
            this.runAction(cc.sequence(
                cc.moveTo(GC.easeDT, cc.p(0, posY)),
                cc.delayTime(0.5),
                cc.callFunc(self.onCallback(), this)
            ));
        } else {
            this.scheduleOnce(function () {
                self.onCallback();
            }.bind(this), GC.easeDT);
        }
        this.hideItems();
    },

    delMenuItems: function () {
        //cc.log("delMenuItems");
        if (GC.menuItems.length > 0) {
            for (var j = 0; j < GC.menuItems.length; j++) {
                GC.menuItems[j].removeFromParent(true);
                if (j == GC.menuItems.length - 1) {
                    GC.menuItems = [];
                }
            }
        }
        if (GC.menu) {
            GC.menu.removeFromParent(false);
        }
    },

    hideTextItem: function () {
        if (this.textItemArr.length < 1) return;
        for (var i = 0, len = this.textItemArr.length; i < len; i++) {
            var textItem = this.textItemArr[i];
            if (textItem) {
                textItem.fadeOutText(0.3);
            }
        }
    },

    stopAllAct: function () {
        for (var i = 0, len = this.children.length; i < len; i++) {
            var child = this.children[i];
            child.stopAllActions();
        }
    },

    changeGetBonusPic: function () {

    },

    outAction: function (act) {
        for (var i = 0, len = this.children.length; i < len; i++) {
            var child = this.children[i];
            if (child) {
                child.runAction(act.clone());
            }
        }
    },

    onCallback: function () {
        cc.log("onCallback");
        this.setVisible(false);
        canChangePage = true;
        this.stopAllActions();
        this.removeAllChildren();
        this.removeFromParent(true);
        GC._layerArr[GC.pageId] = null;
    },

    getTouchBegan: function (touch, event) {},
    getTouchMoved: function (touch, event) {},
    getLongPress: function (touch, event) {},
    getTouchEnded: function (touch, event) {},
    getTouchCancelled: function (touch, event) {},

    touchSelf: function (dir, point) {},

    swipeSelf: function (dirX, dirY) {},

    showIptTips: function (flag) {},

    showItems: function () {},

    hideItems: function () {}
});

//剪辑出现效果类
var TextClipper = cc.Layer.extend({
    type: "TextClipper",
    text: null,

    ctor: function (textRes, pos, dirFlag, dt, delay, isClipperMove) {
        this._super(textRes, pos, dirFlag, dt, delay, isClipperMove);
        if (!delay) delay = 0.2;
        if (!dt) dt = 0.5;
        if (isClipperMove == null) isClipperMove = true;
        //cc.log(textRes, pos, dirFlag, dt, delay, isClipperMove);
        var text = new cc.Sprite(textRes);
        this.text = text;
        //
        var clipper = new cc.ClippingNode();
        clipper.width = text.width;
        clipper.height = text.height;
        clipper.anchorX = 0.5;
        clipper.anchorY = 0.5;
        clipper.x = pos.x;
        clipper.y = pos.y;
        if (dirFlag == 'left') {
            text.x = text.width * 1.5;
            text.xx = text.width * 0.5;
            text.y = text.height * 0.5;
            text.yy = text.height * 0.5;
            if (isClipperMove) {
                clipper.x = pos.x - text.width * 0.5;
                clipper.y = pos.y;
            }
        } else if (dirFlag == 'right') {
            text.x = -text.width * 0.5;
            text.xx = text.width * 0.5;
            text.y = text.height * 0.5;
            text.yy = text.height * 0.5;
            if (isClipperMove) {
                clipper.x = pos.x + text.width * 0.5;
                clipper.y = pos.y;
            }
        } else if (dirFlag == 'up') {
            text.x = text.width * 0.5;
            text.xx = text.x;
            text.y = -text.height * 0.5;
            text.yy = text.height * 0.5;
            if (isClipperMove) {
                clipper.x = pos.x;
                clipper.y = pos.y - text.height * 0.5;
            }
        } else if (dirFlag == 'down') {
            text.x = text.width * 0.5;
            text.xx = text.x;
            text.y = text.height * 1.5;
            text.yy = text.height * 0.5;
            if (isClipperMove) {
                clipper.x = pos.x;
                clipper.y = pos.y + text.height * 0.5;
            }
        }
        clipper.setInverted(false);
        this.addChild(clipper, 0, 0);
        var stencil = new cc.DrawNode();
        var rectangle = [cc.p(0, 0), cc.p(clipper.width, 0),
            cc.p(clipper.width, clipper.height),
            cc.p(0, clipper.height)
        ];

        var white = cc.color(255, 255, 255, 255);
        stencil.drawPoly(rectangle, white, 1, white);
        clipper.stencil = stencil;
        clipper.addChild(text);
        //
        text.opacity = 0;
        text.runAction(cc.sequence(
            cc.delayTime(delay),
            cc.spawn(
                cc.fadeIn(dt),
                cc.moveTo(dt, cc.p(text.xx, text.yy)).easing(cc.easeSineOut())
            )
        ));
        //
        if (isClipperMove) {
            clipper.runAction(cc.sequence(
                cc.delayTime(delay),
                cc.spawn(
                    cc.fadeIn(dt),
                    cc.moveTo(dt, pos).easing(cc.easeSineOut())
                )
            ));
        }
        return true;
    },

    fadeOut: function (dt) {
        if (dt == undefined || dt == null) {
            dt = 0.3;
        }
        this.text.runAction(cc.fadeOut(dt));
    }
});

//跑马灯效果类
var TextScroll = cc.Layer.extend({
    type: "TextScroll",
    textRes: null,
    textArr: [],
    offsetX: 0,
    offsetY: 0,
    dir: -1,
    cnt: 0,
    textWidth: 0,
    orginX: 0,
    orginY: 0,

    ctor: function (textRes, cnt, offsetX, offsetY, dir, dt) {
        this._super(textRes, cnt, offsetX, offsetY, dir, dt);
        if (!dt) dt = 2;
        if (!dir) dir = -1;
        this.textRes = textRes;
        this.offsetX = offsetX;
        this.offsetY = offsetY;
        this.dir = dir;
        this.cnt = cnt;
        this.dt = dt;
        //
        for (var i = 0, len = cnt; i < len; i++) {
            var text = new cc.Sprite(textRes);
            text.anchorX = 0;
            text.xx = (text.width + offsetX) * (i % cnt);
            text.yy = offsetY * (i % cnt);
            text.tid = i;
            text.x = text.xx;
            text.y = text.yy;
            this.addChild(text, i, i);
            this.textArr[i] = text;
            this.textWidth = text.width;
        }
    },

    runRepeat: function () {
        this.orginX = this.x;
        this.orginY = this.y;
        var moveDistance = this.dir * (this.textWidth + this.offsetX);
        this.runAction(cc.sequence(
            cc.moveBy(this.dt, cc.p(moveDistance, this.dir * this.offsetY)),
            cc.callFunc(function () {
                this.x = this.orginX;
                this.y = this.orginY;
            }.bind(this), this)
        ).repeatForever());
    }
});

//dot效果类
var DotSprite = cc.Layer.extend({
    type: "DotSprite",
    dotArr: [],
    maxCnt: 3,

    ctor: function () {
        this._super();
        for (var i = 0, len = this.maxCnt; i < len; i++) {
            var dot = new cc.Sprite("#dot_0000" + i + ".png");
            dot.tid = i;
            dot.crtIndex = i;
            dot.x = (dot.width + 12) * i;
            dot.y = 0;
            this.addChild(dot, i, i);
            this.dotArr[i] = dot;
        }
        this.schedule(this.changeDot, 0.5);
    },

    changeDot: function () {
        // cc.log(this.dotArr.length);
        for (var i = 0, len = this.dotArr.length; i < len; i++) {
            var dot = this.dotArr[i];
            dot.crtIndex++;
            if (dot.crtIndex > this.maxCnt - 1) {
                dot.crtIndex = 0;
            }
            var frame = cc.spriteFrameCache.getSpriteFrame("dot_0000" + dot.crtIndex + ".png");
            dot.setSpriteFrame(frame);
        }
    }
});

//头像遮罩类
var HeadClipper = cc.Layer.extend({
    type: "HeadClipper",
    text: null,

    ctor: function (textRes, maskRes, pos, wd, hg) {
        this._super(textRes, pos, wd, hg);
        var text = new cc.Sprite(textRes);
        var scale = wd / text.width;
        text.scale = scale;
        this.text = text;
        //
        var clipper = new cc.ClippingNode();
        clipper.width = wd;
        clipper.height = hg;
        clipper.anchorX = 0.5;
        clipper.anchorY = 0.5;
        clipper.x = pos.x;
        clipper.y = pos.y;
        //
        clipper.setInverted(false);
        clipper.setAlphaThreshold(0);
        this.addChild(clipper, 0, 0);
        var stencil = new cc.Sprite(maskRes);
        stencil.x = clipper.width * 0.5;
        stencil.y = clipper.height * 0.5;
        clipper.stencil = stencil;
        clipper.addChild(text);
        text.x = clipper.width * 0.5;
        text.y = clipper.height * 0.5;
        return true;
    }
});